=== debian/changelog ===
openmohaa (0.81.1+dfsg-2) unstable; urgency=medium

  * Fix build on mips64el

 -- Sébastien Noel <sebastien@twolife.be>  Tue, 18 Mar 2025 21:20:28 +0100

openmohaa (0.81.1+dfsg-1) unstable; urgency=low

  * Initial release. Closes: #1081834.

 -- Sébastien Noel <sebastien@twolife.be>  Sun, 16 Mar 2025 10:12:45 +0100
