=== debian/control ===
Source: openmohaa
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 bison,
 flex,
 libjpeg-dev,
 libmad0-dev,
 libopenal-dev,
 libsdl2-dev,
 pkgconf,
 zlib1g-dev
Standards-Version: 4.7.2
Homepage: https://github.com/openmoh/openmohaa
Vcs-Browser: https://salsa.debian.org/games-team/openmohaa
Vcs-Git: https://salsa.debian.org/games-team/openmohaa.git

Package: openmohaa
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 openmohaa-common (= ${binary:Version}),
 game-data-packager-runtime (>= 80~),
 mohaa-data | game-data-packager
Description: game engine for "Medal of Honor: Allied Assault"
 Medal of Honor: Allied Assault is a first-person shooter video game
 that simulates infantry combat in the European and North African theaters
 during World War II. It was originally released in 2002.
 .
 OpenMoHAA is a re-implementation, based on ioquake3, that allows playing
 "Medal of Honor: Allied Assault" and its two expansions.
 .
 You will need the original, non-distributable, game data files.
 You can install them by using the game-data-packager tool.

Package: openmohaa-server
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 openmohaa-common (= ${binary:Version}),
 adduser,
 mohaa-data | game-data-packager
Suggests: game-data-packager-runtime (>= 81~)
Description: dedicated server for "Medal of Honor: Allied Assault"
 This package contains a launcher script and systemd unit to run a
 Medal of Honor: Allied Assault server with the openmohaa engine.
 .
 Medal of Honor: Allied Assault is a first-person shooter video game
 that simulates infantry combat in the European and North African theaters
 during World War II. It was originally released in 2002.
 .
 OpenMoHAA is a re-implementation, based on ioquake3, that allows playing
 "Medal of Honor: Allied Assault" and its two expansions.
 .
 You will need the original, non-distributable, game data files.
 You can install them by using the game-data-packager tool.

Package: openmohaa-common
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests: game-data-packager
Description: common files for OpenMoHAA
 This package contains files shared by all openmohaa packages.
 .
 It is unnecessary to install this package unless you are installing one
 of the packages that depends on it.
