=== debian/changelog ===
openmohaa (0.82.1+dfsg-2) unstable; urgency=medium

  * Add upstream patch to fix build on loong64
  * Add d/NEWS to warn users that savegames from v0.81 are incompatible with
    v0.82+ of the engine. Closes: #1114030.

 -- Sébastien Noel <sebastien@twolife.be>  Tue, 06 Jan 2026 11:38:38 +0100

openmohaa (0.82.1+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Sébastien Noel <sebastien@twolife.be>  Mon, 11 Aug 2025 15:05:36 +0200
